
#include <Servo.h> 


// ********************************************  Global variables *************************************************** 
 
Servo myservo;  // create servo object to control a servo 
Servo myservo2;                // a maximum of eight servo objects can be created 
 
int pos = 0;    // variable to store the servo position 

int freedom = 80 ; //degress
int initial_pos = (180 - freedom) / 2;
int limit_pos = (180 - initial_pos);

int ServoDelay = 2;
int ratio = 1.3;
int walkState = 4 ; // 0 = leg forward, 1 = leg backward

int pot1Pin = 0;

// ********************************************  Functions *************************************************** 


// ----------------------- Individual movement --------------------------

void FrontlegForward() {
    Serial.println(" FrontlegForward");
    for(pos = initial_pos; pos < limit_pos; pos += 1)  
      {                                   
        myservo.write(pos);  
        delay(ServoDelay);                       
      } 
}

void FrontlegBackward() {
  Serial.println(" FrontlegBackward");
    for(pos = limit_pos; pos>=initial_pos; pos-=1)     // goes from 180 degrees to 0 degrees 
    {                                
    myservo.write(pos);  
    delay(ServoDelay);    
    }   
}

void BacklegForward() {
  Serial.println(" BacklegForward");  
  for(pos = initial_pos; pos < (limit_pos); pos += 1)  
    {                                   
    myservo2.write(180 - (pos));
    delay(ServoDelay);          
    } 
}

void BacklegBackward() {
    Serial.println(" BacklegBackward");  
    for(pos = limit_pos; pos>=initial_pos; pos-=1)     // goes from 180 degrees to 0 degrees 
    {                                
    myservo2.write(180 - (pos)); 
    delay(ServoDelay);    
    }
}

// ----------------------- Group movement --------------------------

void LegsForward() {
    for(pos = initial_pos; pos < limit_pos; pos += 1)  
      {                                   
        myservo.write(pos);  
        myservo2.write(180- pos);
        delay(ServoDelay);                       
      } 
}

void LegsBackward() {
    for(pos = limit_pos; pos>=initial_pos; pos-=1)     // goes from 180 degrees to 0 degrees 
    {                     
    myservo.write(pos);      
    myservo2.write(180 - pos); 
    delay(ServoDelay);    
    }
}


void InitialPosition() {
    myservo.write(90);                         
    myservo2.write(90);   
}


// ********************************************  Initialisation *************************************************** 

 
void setup() 
{ 
  myservo.attach(2);  // attaches the servo on pin 9 to the servo object 
  myservo2.attach(13);
  
  Serial.begin(9600);
  Serial.println("jinjooBOT - Author : Didier Joomun -  Email : didierjoomun@gmail.com");
  Serial.println("Commands : w,s,q,e,z");
} 
 
 
// ********************************************  Main loop *************************************************** 
 
 
void loop() 
{ 
  //freedom = analogRead(pot1Pin);
  //freedom = map(freedom,0,1023,0,179);

  
  if(Serial.available() >0){
     int inByte = Serial.read();
     
     switch (inByte){
       
       case 'w': // ----------- walk forward -----------------------
         Serial.print("Walk forward : ");
         Serial.print(walkState);
            if (walkState == 4) {
                FrontlegForward();
                walkState = 1;
                break;
               }
               
              if (walkState == 1) {  
                BacklegForward();
                walkState = 2;
                break;
              }
           
             if (walkState == 2) {  
                FrontlegBackward();
                walkState = 3;
                break;
             }
             
             if (walkState == 3) {   
                BacklegBackward();
                walkState = 4;
                break;
             }
      case 's': // ----------- walk backward -----------------------
         Serial.print("Walk backward : ");
         Serial.print(walkState);
         
         
                      
             if (walkState == 1) {   
                BacklegBackward();
                walkState = 4;
                break;
             }
                        
             if (walkState == 4) {  
                FrontlegBackward();
                walkState = 3;
                break;
             }
                            
              if (walkState == 3) {  
                BacklegForward();
                walkState = 2;
                break;
              }
            if (walkState == 2) {
                FrontlegForward();
                walkState = 1;
                break;
               }
               
       case 'z': // ----------- Initial Position -----------------------
           Serial.println("Initial position");
           InitialPosition();
           break;
         
      case 'q': // ----------- Legs forward -----------------------
      if (walkState != 5) {
           Serial.println("Legs forward");
           LegsForward();
           walkState = 5;
           break; 
      } 
                  
      case 'e': // ----------- Legs backward -----------------------
      if (walkState != 6) {
           Serial.println("Legs backward");
           LegsBackward();
           walkState = 6;
           break;  
      }
           
     }
  } 
} 

// ********************************************  End of code *************************************************** 

